unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Menus, StdCtrls, Grids, ValEdit;

type
  TForm3 = class(TForm)
    StatusBar1: TStatusBar;
    Vars: TValueListEditor;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);

  public
    function get(name: string): string;
    procedure put(name, val: string);
    procedure erase(name:string);
  end;

type TOnLoadForm3 = procedure;

var
  Form3: TForm3;
  OnLoadForm3: TOnLoadForm3;

implementation

{$R *.dfm}

// -------------------------------------- TVars -------------------------

procedure TForm3.put(name,val:string);
begin
  vars.Values[name]:=val;
  StatusBar1.Panels[0].Text:=IntToStr(vars.RowCount);
end;

function TForm3.get(name:string):string;
var n:integer;
begin
 if vars.FindRow(name,n) then result:=vars.Cells[1,n]
 else result:=name;
end;

procedure TForm3.erase(name: string);
var n:integer;
begin
 if vars.FindRow(name,n) then
  vars.DeleteRow(n);
 StatusBar1.Panels[0].Text:=IntToStr(vars.RowCount);
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
 OnLoadForm3;
 StatusBar1.Panels[0].Text:=inttostr(vars.RowCount);
 N4.ShortCut:=ShortCut(VK_ESCAPE,[]);
end;

procedure TForm3.N1Click(Sender: TObject);
begin
 vars.InsertRow('','',false);
 StatusBar1.Panels[0].Text:=inttostr(vars.RowCount); 
end;

procedure TForm3.N2Click(Sender: TObject);
begin
 vars.DeleteRow( vars.Selection.TopLeft.y );
 StatusBar1.Panels[0].Text:=inttostr(vars.RowCount);
end;

procedure TForm3.N3Click(Sender: TObject);
begin
 vars.InsertRow('','',true);
 StatusBar1.Panels[0].Text:=inttostr(vars.RowCount);
end;

procedure TForm3.N4Click(Sender: TObject);
begin
 close
end;

end.
